'use strict';

var jsxRuntime = require('react/jsx-runtime');
var React = require('react');
var agGridReact = require('ag-grid-react');
var AgGridUniversalFilter = require('ag-grid-universal-filter');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var AgGridUniversalFilter__default = /*#__PURE__*/_interopDefaultLegacy(AgGridUniversalFilter);

var DefaultContext = {
  color: undefined,
  size: undefined,
  className: undefined,
  style: undefined,
  attr: undefined
};
var IconContext = React__default["default"].createContext && React__default["default"].createContext(DefaultContext);

var __assign = undefined && undefined.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = undefined && undefined.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
function Tree2Element(tree) {
  return tree && tree.map(function (node, i) {
    return React__default["default"].createElement(node.tag, __assign({
      key: i
    }, node.attr), Tree2Element(node.child));
  });
}
function GenIcon(data) {
  // eslint-disable-next-line react/display-name
  return function (props) {
    return React__default["default"].createElement(IconBase, __assign({
      attr: __assign({}, data.attr)
    }, props), Tree2Element(data.child));
  };
}
function IconBase(props) {
  var elem = function (conf) {
    var attr = props.attr,
      size = props.size,
      title = props.title,
      svgProps = __rest(props, ["attr", "size", "title"]);
    var computedSize = size || conf.size || "1em";
    var className;
    if (conf.className) className = conf.className;
    if (props.className) className = (className ? className + " " : "") + props.className;
    return React__default["default"].createElement("svg", __assign({
      stroke: "currentColor",
      fill: "currentColor",
      strokeWidth: "0"
    }, conf.attr, attr, svgProps, {
      className: className,
      style: __assign(__assign({
        color: props.color || conf.color
      }, conf.style), props.style),
      height: computedSize,
      width: computedSize,
      xmlns: "http://www.w3.org/2000/svg"
    }), title && React__default["default"].createElement("title", null, title), props.children);
  };
  return IconContext !== undefined ? React__default["default"].createElement(IconContext.Consumer, null, function (conf) {
    return elem(conf);
  }) : elem(DefaultContext);
}

// THIS FILE IS AUTO GENERATED
function MdOutlineHelpCenter (props) {
  return GenIcon({"tag":"svg","attr":{"viewBox":"0 0 24 24"},"child":[{"tag":"path","attr":{"fill":"none","d":"M0 0h24v24H0z"}},{"tag":"path","attr":{"d":"M13.25 16.74c0 .69-.53 1.26-1.25 1.26-.7 0-1.26-.56-1.26-1.26 0-.71.56-1.25 1.26-1.25.71 0 1.25.55 1.25 1.25zM11.99 6c-1.77 0-2.98 1.15-3.43 2.49l1.64.69c.22-.67.74-1.48 1.8-1.48 1.62 0 1.94 1.52 1.37 2.33-.54.77-1.47 1.29-1.96 2.16-.39.69-.31 1.49-.31 1.98h1.82c0-.93.07-1.12.22-1.41.39-.72 1.11-1.06 1.87-2.17.68-1 .42-2.36-.02-3.08-.51-.84-1.52-1.51-3-1.51zM19 5H5v14h14V5m0-2c1.1 0 2 .9 2 2v14c0 1.1-.9 2-2 2H5c-1.1 0-2-.9-2-2V5c0-1.1.9-2 2-2h14z"}}]})(props);
}

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = ".bond-demo {\r\n  display: flex;\r\n  flex-direction: column;\r\n  margin-top: 20px;\r\n  margin-bottom: 20px;\r\n  height: 750px;\r\n  width: 100%;\r\n}\r\n\r\n.select-area {\r\n  width: 100%;\r\n  margin-top: 10px;\r\n  margin-bottom: 10px;\r\n  display: flex;\r\n  flex-direction: row;\r\n  align-items: center;\r\n}\r\n\r\n.help_container {\r\n  height: 100%;\r\n  padding-top: 10px;\r\n  padding-bottom: 10px;\r\n}\r\n\r\n.help {\r\n  font-size: large;\r\n  border-radius: 5px;\r\n  height: 100%;\r\n  width: 30px;\r\n  align-items: center;\r\n  justify-content: center;\r\n  display: flex;\r\n  padding-left: 3px;\r\n  padding-right: 3px;\r\n  color: var(--universalSelectFontColor);\r\n  background-color: var(--pageColor3);\r\n}\r\n\r\n.headings {\r\n  -webkit-margin-after: 0px;\r\n          margin-block-end: 0px;\r\n}\r\n\r\n.prefixes {\r\n  -webkit-margin-before: 0px;\r\n          margin-block-start: 0px;\r\n  -webkit-margin-after: 0px;\r\n          margin-block-end: 0px;\r\n}";
styleInject(css_248z);

const formatDate = (date) => date.getDate() + '/' + date.getMonth() + '/' + date.getFullYear();
const stringToDate = (text) => {
    const dateParts = text.split('/');
    const day = Number(dateParts[0]);
    const month = Number(dateParts[1]) - 1;
    const year = Number(dateParts[2]);
    return new Date(year, month, day);
};
const stringToIsoDateString = (option) => {
    const dateParts = option.split('/');
    const day = Number(dateParts[0]);
    const month = Number(dateParts[1]) - 1;
    const year = Number(dateParts[2]);
    return new Date(year, month, day).toISOString();
};
const dateCompare = (compareValue, cellValue) => {
    try {
        const cellDateString = cellValue;
        if (cellDateString == null) {
            return 0;
        }
        const cellDate = stringToDate(cellDateString);
        console.log(`${compareValue}==${cellDate}`);
        // Now that both parameters are Date objects, we can compare
        if (cellDate < compareValue) {
            return -1;
        }
        else if (cellDate > compareValue) {
            return 1;
        }
    }
    catch (error) {
        console.log(error);
        return -1;
    }
    return 0;
};
const createDemoModel = (bondList) => {
    const uniqueValues = (column) => {
        // @ts-ignore
        return bondList.map(bond => bond[column])
            .filter((val, idx, arr) => arr.indexOf(val) === idx)
            .sort();
    };
    const isinLlookUp = (text) => __awaiter(void 0, void 0, void 0, function* () {
        return new Promise((resolve) => {
            setTimeout(() => {
                // @ts-ignore
                const list = bondList.map(bond => bond.isinCode)
                    .filter(val => val.toLowerCase().includes(text.toLowerCase()))
                    .filter((val, idx, arr) => arr.indexOf(val) === idx)
                    .sort();
                resolve(list);
            }, Math.floor(Math.random() * 500));
        });
    });
    const definition = (column, prefix, name, regEx) => {
        return {
            key: column,
            prefix,
            options: uniqueValues(column),
            agGridColumn: column,
            choiceDisplayName: name !== null && name !== void 0 ? name : prefix,
            regExMatch: regEx
        };
    };
    const model = {
        choices: [
            {
                key: "isinCode",
                prefix: "Isin",
                lookUp: isinLlookUp,
                agGridColumn: "isinCode",
                choiceDisplayName: "Isin",
                regExMatch: /.*/
            },
            definition("haircutCategory", "Haircut Cut"),
            definition("type", "type", "Type"),
            definition("refMarket", "ref mkt", "Reference Market"),
            definition("demonination", "demon", "Demonination"),
            {
                key: "coupon",
                prefix: "coupon rate",
                agGridColumn: "couponRate",
                choiceDisplayName: "Coupon Rate",
                regExMatch: /^\d{0,1}(\.\d{1,4})?$/,
                filterType: "number",
                replaceExisting: true
            },
            {
                key: "issuranceDate",
                prefix: "issurance date",
                choiceDisplayName: "Issurance Date",
                regExMatch: /^(0?[1-9]|[12][0-9]|3[01])[\-](0?[1-9]|1[012])[\/\-]\d{4}$/,
                agGridColumn: "issuranceDate",
                filterType: "date",
                valueConverter: stringToIsoDateString,
                replaceExisting: true
            },
            {
                key: "maturityDate",
                prefix: "maturity date",
                choiceDisplayName: "Maturity Date",
                regExMatch: /^[0-9]{0,2}$/,
                valueGetter: (text) => {
                    const now = new Date();
                    const years = parseInt(text);
                    return formatDate(new Date(now.setFullYear(now.getFullYear() + years)));
                },
                agGridColumn: "maturityDate",
                filterType: "date",
                valueConverter: stringToIsoDateString,
                replaceExisting: true
            },
            definition("issuerCsd", "csd", "Issuer CSD"),
            {
                key: "issuerName",
                prefix: "issuerName",
                choiceDisplayName: "Issuer Name",
                agGridColumn: "issuerName",
                regExMatch: /.*/,
                replaceExisting: true
            },
            definition("issuerResidence", "issuer res", "Issuser Residence"),
            definition("issuerGroup", "issuer grp", "Issuer Group"),
            {
                key: "guarantorName",
                prefix: "guarantorName",
                choiceDisplayName: "Guarantor Name",
                agGridColumn: "guarantorName",
                regExMatch: /.*/,
                replaceExisting: true
            },
            definition("guarantorResidence", "guarantor res", "Guarantor Residence"),
            definition("guarantorGroup", "guarantor grp", "Guarantor Group"),
            definition("couponDef", "coupon def", "Coupon Definition"),
            {
                key: "haircut",
                prefix: "haircut",
                choiceDisplayName: "Haircut",
                agGridColumn: "haircut",
                regExMatch: /^\d{0,2}(\.\d{1,4})?$/,
                filterType: "number",
                replaceExisting: true
            },
        ],
        columnDefs: [
            { field: "isinCode", headerName: "ISIN Code", filter: "agSetColumnFilter", resizable: true, width: 150 },
            { field: "haircutCategory", headerName: "Haircut Category", filter: "agSetColumnFilter", resizable: true, width: 120 },
            { field: "type", headerName: "Type", filter: "agSetColumnFilter", resizable: true, width: 90 },
            { field: "refMarket", headerName: "Reference", filter: "agSetColumnFilter", resizable: true, width: 120 },
            { field: "demonination", headerName: "Demonination", filter: "agSetColumnFilter", resizable: true, width: 140 },
            { field: "issuranceDate", headerName: "Issuance Date", filter: "agDateColumnFilter", filterParams: { comparator: dateCompare }, resizable: true, width: 130 },
            { field: "maturityDate", headerName: "Maturity Date", filter: "agDateColumnFilter", filterParams: { comparator: dateCompare }, resizable: true, width: 130 },
            { field: "issuerCsd", headerName: "Issuer CSD", filter: "agSetColumnFilter", resizable: true, width: 120 },
            { field: "couponRate", headerName: "Coupon Rate", filter: "agNumberColumnFilter", resizable: true, width: 140 },
            { field: "issuerName", headerName: "Issuer Name", filter: "agTextColumnFilter", resizable: true, width: 300 },
            { field: "issuerResidence", headerName: "Issuer Residence", filter: "agSetColumnFilter", resizable: true, width: 130 },
            { field: "issuerGroup", headerName: "Issuer Group", filter: "agSetColumnFilter", resizable: true, width: 130 },
            { field: "guarantorName", headerName: "Guarantor Name", filter: "agTextColumnFilter", resizable: true, width: 300 },
            { field: "guarantorResidence", headerName: "Guarantor Residence", filter: "agSetColumnFilter", resizable: true, width: 130 },
            { field: "guarantorGroup", headerName: "Guarantor Group", filter: "agSetColumnFilter", resizable: true, width: 130 },
            { field: "couponDef", headerName: "Coupon Definition", filter: "agSetColumnFilter", resizable: true, width: 130 },
            { field: "haircut", headerName: "Haircut", filter: "agNumberColumnFilter", resizable: true, width: 150 }
        ],
        rowData: bondList
    };
    return model;
};

const Demo = ({ bondList }) => {
    const [showHelp, setShowHelp] = React.useState(false);
    const [aggridApi, setAggridApi] = React.useState();
    const model = React.useMemo(() => createDemoModel(bondList), [bondList]);
    const gridReady = (event) => {
        setAggridApi(event.api);
    };
    const gridStyle = {
        flex: 1,
        "--ag-foreground-color": "var(--pageFont)",
        "--ag-background-color": "var(--pageColor5)",
        "--ag-header-foreground-color": "var(--universalSelectFontColor)",
        "--ag-header-background-color": "var(--pageColor2)",
        "--ag-odd-row-background-color": "var(--pageColor4)",
        "--ag-header-column-resize-handle-color": "var(--pageFont)"
    };
    return (jsxRuntime.jsxs("div", Object.assign({ className: "bond-demo" }, { children: [jsxRuntime.jsxs("div", Object.assign({ className: "select-area" }, { children: [jsxRuntime.jsx("div", Object.assign({ className: "help_container" }, { children: jsxRuntime.jsx("div", Object.assign({ className: "help", onClick: () => setShowHelp(!showHelp) }, { children: jsxRuntime.jsx(MdOutlineHelpCenter, {}) })) })), jsxRuntime.jsx(AgGridUniversalFilter__default["default"], { title: "Quick Filter", width: "100%", choices: model.choices, agGridApi: aggridApi })] })), showHelp && jsxRuntime.jsxs("div", Object.assign({ className: "explaination" }, { children: [jsxRuntime.jsx("h4", Object.assign({ className: "headings" }, { children: "Lookup and choices" })), jsxRuntime.jsx("p", Object.assign({ className: "prefixes" }, { children: "Use the below operations to filter the columns. Combinations are possible using &(and) or | (or)" })), jsxRuntime.jsx("h4", Object.assign({ className: "headings" }, { children: "Text columns" })), jsxRuntime.jsx("p", Object.assign({ className: "prefixes" }, { children: "Text columns that do not use lookup or choices (Iusser and Guarantor name) support the following prefixes" })), jsxRuntime.jsx("p", Object.assign({ className: "prefixes" }, { children: "= equals" })), jsxRuntime.jsx("p", Object.assign({ className: "prefixes" }, { children: "! not equals " })), jsxRuntime.jsx("p", Object.assign({ className: "prefixes" }, { children: "% contains" })), jsxRuntime.jsx("p", Object.assign({ className: "prefixes" }, { children: "!% not contains" })), jsxRuntime.jsxs("p", Object.assign({ className: "prefixes" }, { children: ["%", ">", " ends width"] })), jsxRuntime.jsxs("p", Object.assign({ className: "prefixes" }, { children: ["%", "<", " starts width"] })), jsxRuntime.jsx("h4", Object.assign({ className: "headings" }, { children: "Number columns" })), jsxRuntime.jsx("p", Object.assign({ className: "prefixes" }, { children: "Number columns (Coupon and Haircut) support the following prefixes" })), jsxRuntime.jsx("p", Object.assign({ className: "prefixes" }, { children: "= equals" })), jsxRuntime.jsx("p", Object.assign({ className: "prefixes" }, { children: "! not equals" })), jsxRuntime.jsxs("p", Object.assign({ className: "prefixes" }, { children: [">", " greater than"] })), jsxRuntime.jsxs("p", Object.assign({ className: "prefixes" }, { children: ["<", " less than"] })), jsxRuntime.jsxs("p", Object.assign({ className: "prefixes" }, { children: ["<", "= greater than or equal to"] })), jsxRuntime.jsxs("p", Object.assign({ className: "prefixes" }, { children: [">", "= less than or equal to"] })), jsxRuntime.jsx("h4", Object.assign({ className: "headings" }, { children: "Date columns" })), jsxRuntime.jsx("p", Object.assign({ className: "prefixes" }, { children: "Date columns (Maturity and Issurance) support the following prefixes" })), jsxRuntime.jsx("p", Object.assign({ className: "prefixes" }, { children: "= equals" })), jsxRuntime.jsx("p", Object.assign({ className: "prefixes" }, { children: "! not equals" })), jsxRuntime.jsxs("p", Object.assign({ className: "prefixes" }, { children: [">", " greater than"] })), jsxRuntime.jsxs("p", Object.assign({ className: "prefixes" }, { children: ["<", " less than"] })), jsxRuntime.jsx("p", Object.assign({ className: "prefixes" }, { children: "To enter maturity date, simply enter the number of years" })), jsxRuntime.jsx("h4", Object.assign({ className: "headings" }, { children: "Usage" })), jsxRuntime.jsx("p", Object.assign({ className: "prefixes" }, { children: "To use a prefix type it before entering text/numbers as follows" })), jsxRuntime.jsxs("p", Object.assign({ className: "prefixes" }, { children: ["$", ">", "50 = maturity dates greater than current date plus 50"] })), jsxRuntime.jsx("p", Object.assign({ className: "prefixes" }, { children: "%Bank = string contains the letters bank" })), jsxRuntime.jsx("p", Object.assign({ className: "prefixes" }, { children: "!.0 = not where the number is 0 (Coupon and Haircut regex look for floats)" }))] })), jsxRuntime.jsx("div", Object.assign({ className: "ag-theme-alpine", style: gridStyle }, { children: jsxRuntime.jsx(agGridReact.AgGridReact, { rowData: model.rowData, columnDefs: model.columnDefs, onGridReady: gridReady }) }))] })));
};

module.exports = Demo;
